
#line 1 "sensor.h"
#ifndef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src__
#define __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src__
#define __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_sensor_h__
#endif // __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src__

#line 1 "sensor.h"

#line 11 "/home/channgo/Working/plasma_plugins/trunk/Embedded_Probabilistic_Systems/Embedded_Probabilistic_Control_Systems/example/embeddedcontrolsystem/instrumented/sensor.h"
class Automatic;

#line 1 "sensor.h"

#line 16 "/home/channgo/Working/plasma_plugins/trunk/Embedded_Probabilistic_Systems/Embedded_Probabilistic_Control_Systems/example/embeddedcontrolsystem/instrumented/sensor.h"

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 32768, EXECUTION = 65536, CONSTRUCTION = 131072, DESTRUCTION = 262144 };
  enum Protection { PROT_NONE, PROT_PRIVATE, PROT_PROTECTED, PROT_PUBLIC };
  enum Specifiers { SPEC_NONE = 0x0 , SPEC_STATIC = 0x1, SPEC_MUTABLE = 0x2, SPEC_VIRTUAL = 0x4 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    struct { char _array[sizeof (T)]; } _data;
    ~ResultBuffer () { ((T&)_data).T::~T(); }
    operator T& () const { return (T&)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__TI const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> : T::__TI {
    enum { AVAILABLE = 1 };
	 };
  template<typename T> struct RT {};
  template<typename T> RT<T> rt_deduce (const T&) { return RT<T>(); }
  struct Cnv { template<typename T> operator RT<T>() const { return RT<T>(); }};
  #define __AC_TYPEOF(expr) (1?AC::Cnv():AC::rt_deduce(expr))
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned long int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_

#line 1 "sensor.h"
/* Embedded Control System modeling in SystemC
 * Copy right (C) 2015 INRIA, Chan Ngo
 */

/* Sensors implement the M-of-N systems (N-Modular Redundancy) 
 * meaning that the system fails when fewer than M modules 
 * are funtional
 */


#ifndef SENSOR_H
#define SENSOR_H

#include <systemc.h>
#include <tlm.h>

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_cdf.h>


#line 1 "types.h"
/* Embedded control system modeling in SystemC
 * Copy right (C) 2015 INRIA, Chan Ngo
 */


#ifndef TYPES_H
#define TYPES_H

#include <iostream>
#include <iomanip>
#include <string>
#include <systemc.h>


// debug flags
//#define PRINT_DEBUG


// cycles skipped limit
const int MAX_COUNT = 4;
// M-of-N sensor system
const int N_SENSOR = 50;
const int M_SENSOR = 37; // the number of working sensor groups >= 37
// M-of-N actuator system
const int N_ACTUATOR = 30;
const int M_ACTUATOR = 27; // the number of working actuator groups >= 27

// rates, mu = 1/lambda
const double time_unit = 1.0;
const double lambda_sensor = 30.0/(30*24*60*60); // 1 month
const double lambda_actuator = 30.0/(2*30*24*60*60); // 2 months
const double lambda_processor = 30.0/(365*24*60*60); // 1 year
const double lambda_cycle = 30.0/2*30; // 1 minute
const double lambda_transient = 30.0/(24*60*60); // 1 day
const double lambda_reboot = 30.0/30; // 30s = time unit

// matrix of transitions
typedef std::vector< std::vector< double > > qmatrix_t;
typedef std::vector< double > tvector_t;

#endif
#line 1 "utils.h"
/* Embedded Control System modeling in SystemC
 * Copy right (C) 2015 INRIA, Chan Ngo
 */


#ifndef UTILS_H
#define UTILS_H

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_cdf.h>


#line 15 "utils.h"
// get max
double get_max(const double x, const double y);

// general discrete distributions
size_t get_discrete(const gsl_rng *r, size_t K, const double *P);

// gaussian distribution
double get_gaussian(const gsl_rng *r, double sigma, double mu);

// bernoulli distribution
int get_bernoulli(const gsl_rng *r, double p);

// exponential distribution
double get_exponential(const gsl_rng *r, double mu);

// get P(X <= x) of exponential distribution
double get_exponential_P(double x, double mu);


#endif
#line 24 "sensor.h"
SC_MODULE(Sensor) {
#line 183 "/home/channgo/Working/plasma_plugins/trunk/Embedded_Probabilistic_Systems/Embedded_Probabilistic_Control_Systems/example/embeddedcontrolsystem/instrumented/sensor.h"

  template <typename, int = 0> struct __BYPASSSensor {};
  template <typename, int> friend struct __BYPASSSensor;
#line 24 "sensor.h"

	SC_HAS_PROCESS(Sensor);

public:
	// constructor
	Sensor(sc_module_name name, int initstate, gsl_rng *rnd);

	// desstructor
	~Sensor();

	// transition
	void sensor_transition();
	
	// get current state
	int get_currentstate();
	
	// get number of states
	int get_numberofstates();

private:
	// module name
	std::string mname;
	
	// current states
	int s;
	
	// number of states from 0 ... n-1
	int n;
	
	// transition matrix
	// 0: no transition
	// -lamda: self transition
	// +lamda: the transition rate 
	qmatrix_t q_matrix;
	
	// probability vector
	tvector_t probvector;

	// holding time in the current state
	double holdingtime;
	
	// the random generator
	gsl_rng *r;

  friend class ::Automatic;

#line 67 "sensor.h"
};

#endif

#line 239 "/home/channgo/Working/plasma_plugins/trunk/Embedded_Probabilistic_Systems/Embedded_Probabilistic_Control_Systems/example/embeddedcontrolsystem/instrumented/sensor.h"

#ifdef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_sensor_h__
#ifdef __ac_need__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_aspect_definitions_ah__
#ifndef __ac_have__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_aspect_definitions_ah__
#define __ac_have__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_aspect_definitions_ah__
#include "aspect_definitions.ah"
#endif
#endif
#undef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src__
#undef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_sensor_h__
#endif // __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_Embedded_Probabilistic_Systems_Embedded_Probabilistic_Control_Systems_example_embeddedcontrolsystem_src_sensor_h__
